#include <os.h>
#include "output.h"

inline void setPixelBuf(uint8_t* scrbuf, uint16_t x, uint16_t y, uint8_t color){
	uint8_t* p = scrbuf + ((x >> 1) + (y << 7) + (y << 5));
	if(x < SCREEN_WIDTH && y < SCREEN_HEIGHT)
		*p = (x & 1) ? ((*p & 0xF0) | color) : ((*p & 0x0F) | (color << 4));
}

void putChar(uint8_t* scrbuf, uint16_t x, uint16_t y, char chr){
	int i, j, pixelOn;
	for(i = 0; i < CHAR_HEIGHT; i++)
	{
		for(j = 0; j < CHAR_WIDTH; j++)
		{
			pixelOn = charMap_ascii[chr][i] << j ;
			pixelOn = pixelOn & 0x80 ;
			if (pixelOn) {
				setPixelBuf(scrbuf, x + j, y + i, 0);
			} else {
				setPixelBuf(scrbuf, x + j, y + i, 15);
			}
		}
	}
}

void dispString(uint8_t* scrbuf, uint16_t x, uint16_t y, char* message){
	int32_t l = strlen(message);
	int32_t i;
	for (i = 0; i<l; i++){
		putChar(scrbuf, x, y, message[i]);
		x += CHAR_WIDTH;
		if (x >= SCREEN_WIDTH){
			x = 0;
			y += CHAR_HEIGHT;
		}
		if(y + CHAR_HEIGHT >= SCREEN_HEIGHT)//damit nicht speicher hinter screenbuffer berschrieben wird
			break;
	}
}
