#include <os.h>
#include "output.h"

#define REAL_TIME_CLOCK_ADDRESS 0x90090000

int main(){
    uint8_t* scrbuf = (uint8_t*) malloc(SCREEN_BYTES_SIZE);
    memset(scrbuf, 0xFF, SCREEN_BYTES_SIZE);
	int starttime, i;
	uint8_t hours = 0, min = 0, sec = 0;
	char time[10];
	while(!isKeyPressed(KEY_NSPIRE_ESC)){
	    wait_no_key_pressed();
	    sprintf(time, "%i:%i:%i", hours, min, sec);//convert time to string
        dispString(scrbuf, 130, 60, time);
	    dispString(scrbuf, 20, 180, "Start [ENTER]");
	    dispString(scrbuf, 20, 200, "Close program [ESC]");
	    dispString(scrbuf, 20, 220, "Reset [MENU]");
	    memcpy(SCREEN_BASE_ADDRESS, scrbuf, SCREEN_BYTES_SIZE);
	    if(isKeyPressed(KEY_NSPIRE_MENU)){
	        memset(scrbuf, 0xFF, SCREEN_BYTES_SIZE);
	        hours = 0;
	        min = 0;
	        sec = 0;
	    }
	    if(isKeyPressed(KEY_NSPIRE_ENTER)){
	        memset(scrbuf, 0xFF, SCREEN_BYTES_SIZE);
	        starttime = *(int*)REAL_TIME_CLOCK_ADDRESS;
	        i = starttime;
	        wait_no_key_pressed();
	        while(!isKeyPressed(KEY_NSPIRE_ENTER) && !isKeyPressed(KEY_NSPIRE_ESC)){
	            memset(scrbuf, 0xFF, SCREEN_BYTES_SIZE);
	            if(isKeyPressed(KEY_NSPIRE_MENU)){
                    hours = 0;
                    min = 0;
                    sec = 0;
                }
	            if(i < *(int*)REAL_TIME_CLOCK_ADDRESS){
	                i++;
	                sec++;
	            }
	            if(sec == 60){
	                sec = 0;
	                min++;
	            }
	            if(min == 60){
	                min = 0;
	                hours++;
	            }
                sprintf(time, "%i:%i:%i", hours, min, sec);//convert time to string
                dispString(scrbuf, 130, 60, time);
                dispString(scrbuf, 20, 180, "Start [ENTER]");
                dispString(scrbuf, 20, 200, "Close program [ESC]");
                dispString(scrbuf, 20, 220, "Reset [MENU]");
                memcpy(SCREEN_BASE_ADDRESS, scrbuf, SCREEN_BYTES_SIZE);
	        }
	    }
	}
	return 0;
}
